#include <Wire.h>

#include <Adafruit_BMP280.h>

#include <SPI.h>

float Temperature_120311341_2;
float Pressure_120311341_2;
float Altitude_120311341_2;
#define SEALEVELPRESSURE_HPA_120311341_2 (1013.25)

Adafruit_BMP280 bme_120311341_2; // I2C
#define BMP280_ADDRESS_120311341_2 (0x76)

bool en_10700381_2;
float Val_10700381_2;
float Xe_10700381_2;
float Pc_10700381_2;
float G_10700381_2;
float P_10700381_2= 1.0;
float Xp_10700381_2= 0.0;
float Zp_10700381_2= 0.0;
bool _gtv2; //Тактовый генератор
bool _gtv1; //Начальная установка
int _gtv3; //Привязка к местности
int _gtv4; //Привязка к местности
int _gtv5; //Данные высоты
bool _trgrt1 = 0;
bool _trgrt1I = 0;
bool _gen2I = 0;
bool _gen2O = 0;
unsigned long _gen2P = 0UL;
bool _gen3I = 0;
bool _gen3O = 0;
unsigned long _gen3P = 0UL;
void setup()
{
analogReference(EXTERNAL);
if (!bme_120311341_2.begin()) {  
    Serial.println("Could not find a valid BMP280 sensor, check wiring!");
    while (1);
  }

}
void loop()
{




//Плата:1
if (1) { if (! _gen3I) { _gen3I = 1; _gen3O = 1; _gen3P = millis(); } } else { _gen3I = 0 ; _gen3O= 0;}
 if (_gen3I) {  if ( _isTimer ( _gen3P , 20 )) { _gen3P = millis(); _gen3O = ! _gen3O;}}
if (_gen3O) { if (_trgrt1I) { _trgrt1 = 0;} else {_trgrt1 = 1; _trgrt1I = 1;} } else {_trgrt1 = 0; _trgrt1I = 0;}; 
 _gtv2 = _trgrt1;
if (1) {if (! _gen2I){_gen2I = 1; _gen2O = 1; _gen2P = millis();}} else { _gen2I = 0 ; _gen2O= 0; } if (_gen2I &&  _gen2O)   _gen2O = !( _isTimer( _gen2P , 6000 ));
_gtv1 = _gen2O;
Temperature_120311341_2 = bme_120311341_2.readTemperature();
Pressure_120311341_2 = bme_120311341_2.readPressure() / 100.0F * 0.7500;
Altitude_120311341_2 = bme_120311341_2.readAltitude(SEALEVELPRESSURE_HPA_120311341_2);

en_10700381_2 = _gtv2;
Val_10700381_2 = Altitude_120311341_2;

// Filtr_Kalman
if ( en_10700381_2 )
{
Pc_10700381_2 = P_10700381_2 + 0.05;
G_10700381_2 = Pc_10700381_2 / ( Pc_10700381_2 + 0.25 );
P_10700381_2 = (1 - G_10700381_2) * Pc_10700381_2;
Xp_10700381_2 = Xe_10700381_2;
Zp_10700381_2 = Xp_10700381_2;
Xe_10700381_2 = G_10700381_2 * ( Val_10700381_2 - Zp_10700381_2 ) + Xp_10700381_2; // "фильтрованное" значение
}

_gtv3 = (Xe_10700381_2)*(100);
if (_gtv1) {
_gtv4 = (Xe_10700381_2)*(100);
}
_gtv5 = (_gtv3)-(_gtv4);




}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }
